!!ARBfp1.0

OUTPUT output = result.color;
TEMP intg, frac, frac_1, tmp;
TEMP g0, g1, u, v, noise;

#PARAM size = 64.0;
#PARAM invSize = 0.015625;
#PARAM invHalfSize = 0.0078125;

PARAM col = { 1, 0.5, 0, 0 };

PARAM size = program.local[0];
PARAM time = program.local[1];


MUL		tmp, fragment.texcoord[0], size.x;

FLR		intg, tmp;
FRC		frac, tmp;
SUB		frac_1, frac, 1.0;

MAD		tmp, intg, size.y, -size.z;
TEX		g0, tmp, texture[0], 2D;          # Sample X values from the four surrounding texels
TEX		g1, tmp, texture[1], 2D;          # Sample Y values from the four surrounding texels

MAD		g0, g0, 2.0, -1.0;                # Expand [0, 1] to [-1, 1]
MAD		g1, g1, 2.0, -1.0;


MUL		u.x, frac.x,   g0.x;              # Filter
MAD		u.x, frac.y,   g1.x, u.x;

MUL		v.x, frac_1.x, g0.y;
MAD		v.x, frac.y,   g1.y, v.x;

MUL		u.y, frac.x,   g0.z;
MAD		u.y, frac_1.y, g1.z, u.y;

MUL		v.y, frac_1.x, g0.w;
MAD		v.y, frac_1.y, g1.w, v.y;


MAD		tmp, -2, frac, 3;                 # s_curve(t) = t * t * (3 - 2 * t)
MUL		frac, frac, frac;
MUL		frac, frac, tmp;

LRP		noise, frac.x, v, u;
LRP		noise, frac.y, noise.y, noise.x;  # .. and the Perlin noise is done

MAD		noise, noise, 6.2832, time;
COS		noise, noise.x;
#ABS		output, noise;


MAD		output, noise, 0.5, 0.5;


  
END 
